
      /*
       *  main.cpp
       *
       *  Copyright (c) 2008 by Kuscsik Peter <kuscsikp@gmail.com>
       *
       *  This program is free software; you can redistributeprocs_online it and/or modify
       *  it under the terms of the GNU General Public License as published by
       *  the Free Software Foundation; either version 2 of the License, or
       *  (at your option) any later version.
       *
       *  This program is distributed in the hope that it will be useful,
       *  but WITHOUT ANY WARRANTY; without even the implied warranty of
       *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       *  GNU General Public License for more details.
       *
       *  You should have received a copy of the GNU General Public License
       *  along with this program; if not, write to the Free Software
       *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
       *  USA.
       */ 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifdef __WIN32__
#else
#include "sys/time.h"
#include <sys/times.h>
#endif

#include "cross.h"
#include "aurora.h"
#include "cpuid.h"
#include "mem_test.h"

const char *host_detect_local_cpu ();
void *host_detect_multi_cpu ();

int main(int argc, char *argv[])
{


/*	if (argc>1)
		if (strcmp("-si",argv[1])==0){	
			cpuid.display_sinfo ();
			return 0;
		}
*/
	if (argc>1)
		if (strcmp("-si",argv[1])==0) {	
			init_cpuid();
			show_cpuid_short();
			return 0;
		}

	if (argc>1) {
		if (strcmp("-f",argv[1])==0) {
			printf("-march=%s -O2 -pipe -fomit-frame-pointer\n", host_detect_local_cpu());	
			return 0;
			}		
		}
	#ifdef __WIN32__
    	printf("Procbench v0.8.2a for Windows, Peter Kuscsik, 2008\n");
	#else
    	printf("Procbench v0.8.2a, Peter Kuscsik, 2008\n");
	#endif
	printf("Use -h flag to display help.\n");
	cmem mem;

	for (int l=0; (l<argc); l++) {
		if ((strcmp("-h",argv[l])==0) || (strcmp("--help",argv[l])==0)) {
			printf("Usage:	procbench [options]\n");
			printf("List information about (current) x86 processor\n");
		    	printf("Options are:\n"); 
		    	printf("	-h	display this help and exit\n");
			printf("	-c	show CPUID information\n");
			//printf("	-mp	multi-processor information\n");
			printf("	-d	dump CPUID\n");
			//printf("	-si	display only a short information\n");  		<< secret:)
			printf("	-i	instruction latency meter (experimental)\n");
			printf("	-m	memory transfer speed test\n");
			printf("	-f	display best optimisation flags for GCC\n");

		}
		if (strcmp("-c",argv[l])==0) {	
			init_cpuid();
			host_detect_multi_cpu();	
			show_cpuid();
		}
		if (strcmp("-i",argv[l])==0) mem.instr_test();
		if (strcmp("-d",argv[l])==0) {
			init_cpuid();		 
			dump_cpuid();
			}		
		if (strcmp("-m",argv[l])==0) mem.mem_speed_test();
		if (strcmp("-f",argv[l])==0) printf("-march=%s -O2 -pipe -fomit-frame-pointer\n", host_detect_local_cpu());
		//if (strcmp("-mp",argv[l])==0) host_detect_multi_cpu();
		if (strcmp("--version",argv[l])==0) printf("Version : 0.8.2alpha\n");
	}

    	return 0;
}
